"""
author : Abhijeet Pandey
"""

from django import forms
from django.contrib.auth.models import User
from models import Gallery

class GalleryForm(forms.Form):
    album = forms.CharField()
    description= forms.CharField(widget=forms.Textarea)
    
    
    def __init__(self, user, *args, **kwargs): 
        """
        I've added this for checking the integrity of albums. By this i fetch the current user.
        """
        self.user = user
        super(GalleryForm, self).__init__(*args, **kwargs)
  
    def clean_album(self):
        """
        As i've fetched current user, now I can check for the album name , i.e. if any album
        with the name as entered by the user exists or not.
        """
        try:
            gallery = Gallery.objects.get(user=self.user, album_name=self.cleaned_data['album'])
        except Gallery.DoesNotExist:
            return self.cleaned_data['album']
       
        raise forms.ValidationError("Album with this name already exists.")
        
        
   
        
class AlbumsForm(forms.Form):
    image = forms.ImageField()
    description= forms.CharField(widget=forms.Textarea)
    
    