from django.db import models
from django.contrib.auth.models import User
import os

def upload_path_handler(instance, filename):
    return "user_{id}/uploads/{file}".format(id=instance.user.id, file=filename.replace('\\','/'))

# Create your models here.
class Gallery(models.Model):
    user        = models.ForeignKey(User)
    album_name  = models.CharField(max_length="30", blank=False)
    album_description = models.TextField()
    albumcover  = models.FilePathField(default=os.path.join('/mmedia/', 'images/albumcoverdefault.png'))
         
    def __unicode__(self):
        return u"%s %s " % (self.user.username, self.album_name)

class Albums(models.Model):
    user        = models.ForeignKey(User)
    album_name  = models.CharField(max_length="30")
    image       = models.ImageField(upload_to=upload_path_handler, blank=False)
    image_description = models.TextField()
    albumcover  = models.BooleanField(default=False)
   
    
    def __unicode__(self):
        return u"%s %s %s" % (self.user.username, self.album_name, self.image.name)