from django.contrib.auth.decorators import login_required
from django.http import  HttpResponseRedirect , HttpResponse
from django.shortcuts import render_to_response
from GalleryWebsite.gallery.models import Gallery
from django.template import RequestContext
from GalleryWebsite.gallery.forms import GalleryForm, AlbumsForm
from GalleryWebsite.gallery.models import Albums
from django.core.files.storage import default_storage
from GalleryWebsite.profiles.models import Profile 
import os

@login_required
def gallery_newalbum(request, template_name='gallery/addalbum.html'):
       
    if request.POST:
        gallery_form = GalleryForm(request.user, request.POST)
        if gallery_form.is_valid():
            album= gallery_form.cleaned_data['album']
            description = gallery_form.cleaned_data['description']
            gallery= Gallery(user= request.user, album_name=album, album_description=description)
            gallery.save()
            return HttpResponseRedirect('/gallery/') 
        
    else:
        gallery_form=GalleryForm(request.user)
    
    context={'gallery_form': gallery_form}
         
    return render_to_response(template_name, context, context_instance=RequestContext(request))

    

@login_required
def gallery_album_newimage(request, template_name='gallery/addimage.html'):
    
    if request.method=="POST":
            albumname=request.REQUEST["albumname"]
            albums_form = AlbumsForm(request.POST, request.FILES)
            if albums_form.is_valid():
                imagepath=albums_form.cleaned_data['image']
                description=albums_form.cleaned_data['description']
                image= Albums(user=request.user, album_name=albumname, image=imagepath, image_description=description)
                image.save()
                return HttpResponseRedirect('/gallery/')
                
            context={'albums_form': albums_form, 'albumname':albumname,}
            return render_to_response(template_name, context, context_instance=RequestContext(request))
        
    else:
        return HttpResponseRedirect('/gallery/')



@login_required
def gallery_viewalbum(request):
    
    if request.method=="POST":
        albumname=request.REQUEST["albumname"]
        mode=request.REQUEST["mode"]
        
        
        
        if(mode=="view"):
            template_name='gallery/images.html'
            album=Gallery.objects.get(user=request.user, album_name=albumname)
            image_list = Albums.objects.filter(user=request.user ,album_name=albumname)
            if image_list:
                context = { 'image_list':image_list, 'album':album, }
                return render_to_response(template_name, context, context_instance=RequestContext(request))
            else:
                context = {'album':album,  }
                return render_to_response(template_name, context, context_instance=RequestContext(request))
        
        if(mode=="makecover"):
            imagename=request.REQUEST["imagename"]
            image=Albums.objects.filter(user=request.user, album_name=albumname, albumcover=True)
            if image:
                Albums.objects.filter(user=request.user, album_name=albumname, image= image[0].image).update(albumcover=False)
                
            Albums.objects.filter(user=request.user, album_name=albumname, image= imagename).update(albumcover=True)
            Gallery.objects.filter(user=request.user, album_name=albumname).update(albumcover= os.path.join('/mmedia/',imagename))
            return HttpResponseRedirect('/gallery/')
           
        
        
        
        else:
            imagename=request.REQUEST["imagename"]
            image=Albums.objects.get(user=request.user, album_name=albumname, image=imagename)
            if albumname=='Profile Pics':
                profile = Profile.objects.get(user=request.user)
                if image.image.path== profile.profilepic.path:
                    Profile.objects.filter(user=request.user).update(profilepic=os.path.join('','images/albumcoverdefault.png'))
            if image.albumcover==True:
                Gallery.objects.filter(user=request.user, album_name=albumname).update(albumcover=os.path.join('/mmedia/', 'images/albumcoverdefault.png'))
            
            
            path=os.path.join('/mmedia/', image.image.path)
            image.delete()
            if os.path.exists(path):
                os.remove(path)
            return HttpResponseRedirect('/gallery/')
            
        
        
    else:
        return HttpResponseRedirect('/gallery/')
                

@login_required
def gallery_albums(request, template_name='gallery/albums.html'):
     
    if request.method=="GET" :
        
        gallery = Gallery.objects.filter(user=request.user)
        
        if gallery:
            albums = Gallery.objects.filter(user=request.user)
            if albums:
                context = { 'albums':albums, }
                return render_to_response(template_name, context, context_instance=RequestContext(request))
        else:            
            context = {  }
            return render_to_response(template_name, context, context_instance=RequestContext(request))
    
    else:
        albumname=request.REQUEST["albumname"]
        album= Gallery.objects.get(user=request.user, album_name=albumname)
        images= Albums.objects.filter(user=request.user, album_name=albumname)
        
        if albumname=='Profile Pics':
            Profile.objects.filter(user=request.user).update(profilepic=os.path.join('','images/albumcoverdefault.png'))
                
        for image in images:
            path=os.path.join('/mmedia/', image.image.path)
            if os.path.exists(path):
                os.remove(path)
            
        images.delete()
        album.delete()
        return HttpResponseRedirect('/gallery/')
        
         
         
         
               
            
    