from GalleryWebsite.profiles.forms import *
from GalleryWebsite.profiles.models import *
from django.contrib.auth.views import *
from django.core.urlresolvers import reverse
from django.http import Http404, HttpResponseRedirect, HttpResponse
from django.shortcuts import render_to_response
from django.template import RequestContext
from GalleryWebsite.gallery.models import Gallery, Albums

@login_required
def test(request):
    return HttpResponse(request.user.profilepic)



@login_required
def profile_pic_change(request):
    
    if request.method=="POST":
        profile = Profile.objects.get(user=request.user)
                
        if profile:
            profile_pic_form=ProfilePicForm(request.POST, request.FILES, instance=profile)
            
               

        if profile_pic_form.is_valid() :
            profile_pic_form.save()
            profile = Profile.objects.get(user=request.user)
            profilepic=profile.profilepic
            gallery=Gallery.objects.filter(user=request.user, album_name='Profile Pics')
            if gallery:
                image=Albums(user=request.user, album_name='Profile Pics', image=profilepic)
                image.save()    
                
            else:
                gallery=Gallery(user=request.user, album_name='Profile Pics')
                gallery.save()
                image=Albums(user=request.user, album_name='Profile Pics', image=profilepic)
                image.save()    
            return HttpResponseRedirect('/profile/') 
        
        else:
            profile = Profile.objects.get(user=request.user)
            aboutme=profile.aboutme
            context = {
            'profile_form': ProfileForm(instance=profile), 
            'user_form': UserForm(instance=request.user),
            'about_me_form': AboutMeForm(initial={'aboutme': aboutme} ),
            'profile_pic_form': ProfilePicForm(instance=profile),
             'profilepic': profile.profilepic,
             }    
    
    return render_to_response('profiles/profile_form.html', context, context_instance=RequestContext(request))

        


@login_required
def profile_create(request):
    
     if request.user.is_authenticated():   
        profile=Profile(user_id=request.user.id)
        profile.save()
        return HttpResponseRedirect('/profile/edit/')


@login_required         
def profile_detail(request):
    try:
        profile = Profile.objects.get(user=request.user)
    except Profile.DoesNotExist:
        return HttpResponseRedirect('/profile/create/')
          
    if profile:
        context = { 'object':profile }
        return render_to_response('profiles/profile_detail.html', context, context_instance=RequestContext(request))
  
        


@login_required
def profile_edit(request, template_name='profiles/profile_form.html'):
    
    try:
        profile = Profile.objects.get(user=request.user)
    except Profile.DoesNotExist:
        return HttpResponseRedirect('/profile/')

    if request.POST:
        
        profile = Profile.objects.get(user=request.user)
                
        if profile:
            profile_form = ProfileForm(request.POST, instance=profile)
            user_form = UserForm(request.POST, instance=request.user)
            profile_pic_form=ProfilePicForm(request.POST, request.FILES, instance=profile)
            about_me_form=AboutMeForm(request.POST)
               

        if profile_form.is_valid() and user_form.is_valid() and about_me_form.is_valid():
            profile_form.save()
            user_form.save()
            aboutme=about_me_form.cleaned_data['aboutme']
            Profile.objects.filter(user=request.user).update(aboutme=aboutme)
            return HttpResponseRedirect('/profile/') 
       
        
        else:
            context = {
                'profile_form': profile_form, 
                'user_form': user_form,
                'about_me_form': about_me_form,
                'profile_pic_form':profile_pic_form,
                'profilepic': profile.profilepic,
            }
    else:
        profile = Profile.objects.get(user=request.user)
        aboutme=profile.aboutme
        context = {
            'profile_form': ProfileForm(instance=profile), 
            'user_form': UserForm(instance=request.user),
            'about_me_form': AboutMeForm(initial={'aboutme': aboutme} ),
            'profile_pic_form': ProfilePicForm(instance=profile),
             'profilepic': profile.profilepic,
          }    
    return render_to_response(template_name, context, context_instance=RequestContext(request))
